#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "utils.h"

#define PACKAGE "wmdrawer"
#define VERSION "0.10.4"
#define RELEASE_DATE "2003-08-27"

#define MAX_ICON_SIZE 128
#define MIN_ICON_SIZE 12

enum dir {
  topToBottom,
  rightToLeft,
  bottomToTop,
  leftToRight
};

typedef struct ShadingInfo {
  XColor tintColor;
  int shading;
} ShadingInfo;

typedef struct _drawingArea {
  Window win;
  Pixmap pixmap;
  GC     gc;
  XGCValues xgcv;
  XSetWindowAttributes xswa;
} drawingArea;

typedef struct _drawerButton {
  drawingArea da;
  unsigned int isEmpty;
  char *tooltip;
  char *image;
  char *command;
} drawerButton;

typedef struct _drawerConfig {
  char *dockIcon;
  char *iconsBg;
  int  iconsExpand;
  int  transparency;
  int  dockW;
  int  dockH;
  int  btnsSize;
  int  direction;
  int  animationSpeed;
  int  cursor;
  int  borderSize;
  int  showOnHover;
  int  hideOnOut;
  int  hideTimeout;
  int  windowedMode;
  int  windowedModeLocked;
  char *instanceName;
  int  highlight;
  char *highlightImg;
  ShadingInfo highlightShading;
  int tooltips;
  char *tooltipsFont;
  time_t lastModif;  
  char **imagesPaths;
  drawerButton **entries;
} drawerConfig;
